# $Revision: 1.141.2.23 $, $Date: 2008-02-15 01:29:33 $
#
# Conditional build:
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	up		# don't build UP module
%bcond_without	smp		# don't build SMP module
%bcond_without	userspace	# don't build userspace tools
%bcond_with	verbose		# verbose build (V=1)
%bcond_without	incall		# include all sources in srpm

%if %{without kernel}
%undefine with_dist_kernel
%endif
%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif

%define		_min_eq_x11	1:6.9.0
%define		_max_x11	1:7.0.0
%define		x11ver		x690

%ifarch %{ix86}
%define		arch_sufix	""
%define		arch_dir	x86
%else
%define		arch_sufix	_64a
%define		arch_dir	x86_64
%endif

%define		pname	X11-driver-firegl
Summary:	Linux Drivers for ATI graphics accelerators
Summary(pl):	Sterowniki do akceleratorw graficznych ATI
Name:		%{pname}%{_alt_kernel}
Version:	8.36.5
Release:	62
License:	ATI Binary (parts are GPL)
Group:		X11
Source0:	http://www2.ati.com/drivers/linux/ati-driver-installer-%{version}-x86.x86_64.run
# Source0-md5:	bf056417ac6c57acdf5e5a6bb99a7dae
Patch0:		firegl-panel.patch
Patch1:		firegl-panel-ugliness.patch
Patch2:		%{pname}-kh.patch
Patch3:		%{pname}-viak8t.patch
# Patch4:		%{pname}-force-define-AGP.patch
URL:		http://ati.amd.com/support/drivers/linux/linux-radeon.html
#BuildRequires:	X11-devel >= %{_min_eq_x11}	# disabled for now
%{?with_dist_kernel:BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.14}
%{?with_userspace:BuildRequires:	qt-devel}
BuildRequires:	rpmbuild(macros) >= 1.406
Requires:	X11-OpenGL-core >= %{_min_eq_x11}
Requires:	X11-Xserver
%{?with_kernel:Requires:	X11-driver-firegl(kernel)}
Requires:	X11-libs < %{_max_x11}
Requires:	X11-libs >= %{_min_eq_x11}
Requires:	X11-modules < %{_max_x11}
Requires:	X11-modules >= %{_min_eq_x11}
Provides:	X11-OpenGL-libGL
Provides:	XFree86-OpenGL-libGL
Obsoletes:	Mesa
Obsoletes:	X11-OpenGL-libGL
Obsoletes:	XFree86-OpenGL-libGL
Obsoletes:	XFree86-driver-firegl
ExclusiveArch:	i586 i686 athlon pentium3 pentium4 %{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_ccver	%(rpm -q --qf "%{VERSION}" gcc | sed 's/\\..*//')

%define		_noautoreqdep	libGL.so.1

%define		_prefix		/usr/X11R6
%define		_mandir		%{_prefix}/man

%description
Display driver files for the ATI Radeon 8500, 9700, Mobility M9 and
the FireGL 8700/8800, E1, Z1/X1 graphics accelerators. This package
provides 2D display drivers and hardware accelerated OpenGL.

%description -l pl
Sterowniki do kart graficznych ATI Radeon 8500, 9700, Mobility M9 oraz
graficznych akceleratorw FireGL 8700/8800, E1, Z1/X1. Pakiet
dostarcza sterowniki obsugujce wywietlanie 2D oraz sprztowo
akcelerowany OpenGL.

%package -n kernel%{_alt_kernel}-video-firegl
Summary:	ATI kernel module for FireGL support
Summary(pl):	Modu jdra oferujcy wsparcie dla ATI FireGL
License:	ATI
Group:		Base/Kernel
%{?with_dist_kernel:Requires:	kernel%{_alt_kernel}(vermagic) = %{_kernel_ver}}
Requires(post,postun):	/sbin/depmod
Provides:	X11-driver-firegl(kernel)

%description -n kernel%{_alt_kernel}-video-firegl
ATI kernel module for FireGL support.

%description -n kernel%{_alt_kernel}-video-firegl -l pl
Modu jdra oferujcy wsparcie dla ATI FireGL.

%package -n kernel%{_alt_kernel}-smp-video-firegl
Summary:	ATI kernel module for FireGL support
Summary(pl):	Modu jdra oferujcy wsparcie dla ATI FireGL
License:	ATI
Group:		Base/Kernel
%{?with_dist_kernel:Requires:	kernel%{_alt_kernel}-smp(vermagic) = %{_kernel_ver}}
Requires(post,postun):	/sbin/depmod
Provides:	X11-driver-firegl(kernel)

%description -n kernel%{_alt_kernel}-smp-video-firegl
ATI kernel module for FireGL support.

%description -n kernel%{_alt_kernel}-smp-video-firegl -l pl
Modu jdra oferujcy wsparcie dla ATI FireGL.

%prep
%setup -q -c -T

sh %{SOURCE0} --extract .

cp arch/%{arch_dir}/lib/modules/fglrx/build_mod/* common/lib/modules/fglrx/build_mod

install -d panel_src
tar -xzf common/usr/src/ati/fglrx_panel_sources.tgz -C panel_src
%patch0 -p1
%patch1 -p1
cd common
%{?with_dist_kernel:%patch2 -p1}
%patch3 -p1
# %patch4 -p2
cd -

install -d common%{_prefix}/{%{_lib},bin}
cp -r %{x11ver}%{arch_sufix}%{_prefix}/%{_lib}/* common%{_prefix}/%{_lib}
cp -r %{x11ver}%{arch_sufix}%{_bindir}/* common%{_bindir}
cp -r arch/%{arch_dir}%{_prefix}/%{_lib}/* common%{_prefix}/%{_lib}
cp -r arch/%{arch_dir}%{_bindir}/* common%{_bindir}

%build
%if %{with kernel}
cd common/lib/modules/fglrx/build_mod
cp -f 2.6.x/Makefile .
%build_kernel_modules -m fglrx GCC_VER_MAJ=%{_ccver}
cd -
%endif

%if %{with userspace}
%{__make} -C panel_src \
	C="%{__cc}" \
	CC="%{__cxx}" \
	CCFLAGS="%{rpmcflags} -DFGLRX_USE_XEXTENSIONS" \
	MK_QTDIR=/usr \
	LIBQT_DYN=qt-mt
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with kernel}
%install_kernel_modules -m common/lib/modules/fglrx/build_mod/fglrx -d misc
%endif

%if %{with userspace}
install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir},%{_includedir}/X11/extensions} \
	$RPM_BUILD_ROOT/usr/{%{_lib},include/GL}

install common%{_bindir}/{fgl_glxgears,fglrxinfo,aticonfig} \
	$RPM_BUILD_ROOT%{_bindir}
install panel_src/fireglcontrol.qt3.gcc%(gcc -dumpversion) \
	$RPM_BUILD_ROOT%{_bindir}/fireglcontrol
cp -r common%{_prefix}/%{_lib}/* $RPM_BUILD_ROOT%{_libdir}

ln -sf libGL.so.1 $RPM_BUILD_ROOT%{_libdir}/libGL.so

# OpenGL ABI for Linux compatibility
ln -sf %{_libdir}/libGL.so.1 $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so.1
ln -sf %{_libdir}/libGL.so $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so

install common/usr/include/GL/*.h $RPM_BUILD_ROOT/usr/include/GL
install common%{_includedir}/X11/extensions/*.h $RPM_BUILD_ROOT%{_includedir}/X11/extensions
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	-n kernel%{_alt_kernel}-video-firegl
%depmod %{_kernel_ver}

%postun -n kernel%{_alt_kernel}-video-firegl
%depmod %{_kernel_ver}

%post	-n kernel%{_alt_kernel}-smp-video-firegl
%depmod %{_kernel_ver}smp

%postun -n kernel%{_alt_kernel}-smp-video-firegl
%depmod %{_kernel_ver}smp

%if %{with userspace}
%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_libdir}/libGL.so.*.*
%attr(755,root,root) %{_libdir}/libGL.so
%attr(755,root,root) %{_libdir}/libfglrx_dm.so.*.*
%attr(755,root,root) %{_libdir}/libfglrx_gamma.so.*.*
%attr(755,root,root) %{_libdir}/libfglrx_pp.so.*.*
%attr(755,root,root) %{_libdir}/libfglrx_tvout.so.*.*
# Linux OpenGL ABI compatibility symlinks
%attr(755,root,root) /usr/%{_lib}/libGL.so.1
%attr(755,root,root) /usr/%{_lib}/libGL.so

#%%attr(755,root,root) %{_libdir}/modules/dri/atiogl_a_dri.so
%attr(755,root,root) %{_libdir}/modules/glesx.so
%attr(755,root,root) %{_libdir}/modules/dri/fglrx_dri.so
%attr(755,root,root) %{_libdir}/modules/drivers/fglrx_drv.so
%attr(755,root,root) %{_libdir}/modules/linux/libfglrxdrm.so

%doc ATI_LICENSE.TXT common%{_docdir}/fglrx/*.html common%{_docdir}/fglrx/articles common%{_docdir}/fglrx/release-notes common%{_docdir}/fglrx/user-manual

# -devel
#%attr(755,root,root) %{_libdir}/libfglrx_gamma.so
#%{_includedir}/X11/include/libfglrx_gamma.h
#/usr/include/GL/glATI.h
#/usr/include/GL/glxATI.h

# -static
#%{_libdir}/libfglrx_gamma.a
#%{_libdir}/libfglrx_pp.a
#%{_libdir}/modules/esut.a
%endif

%if %{with kernel}
%if %{with up} || %{without dist_kernel} || %{with desktop_kernel}
%files -n kernel%{_alt_kernel}-video-firegl
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/misc/*.ko*
%endif

%if %{with smp} && %{with dist_kernel}
%files -n kernel%{_alt_kernel}-smp-video-firegl
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}smp/misc/*.ko*
%endif
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: X11-driver-firegl.spec,v $
Revision 1.141.2.23  2008-02-15 01:29:33  glen
- use kernel vermagic in deps

Revision 1.141.2.22  2008-02-12 11:01:10  glen
- release 61 (kernel-2.6.16.60-4)

Revision 1.141.2.21  2008-01-28 09:33:20  glen
- rel 60 (kernel-2.6.16.60-1)

Revision 1.141.2.20  2008-01-21 08:28:14  glen
- rel 59 (2.6.16.59-2)

Revision 1.141.2.19  2008-01-18 12:26:08  glen
- rel 58 (2.6.16.58-1)

Revision 1.141.2.18  2007/11/06 21:11:10  glen
- add desktop_kernel bcond to be able to build module for kernel-desktop.spec

Revision 1.141.2.17  2007/11/06 18:28:31  glen
- rel 57 (2.6.16.57-1)

Revision 1.141.2.16  2007/11/04 20:22:05  glen
- prefix src package with alt kernel if present

Revision 1.141.2.15  2007/11/01 08:24:18  adamg
- release 56 (rebuild against 2.6.16.56-1)

Revision 1.141.2.14  2007/10/22 20:41:53  glen
- disable userspace for alt kernel

Revision 1.141.2.13  2007/10/22 20:24:59  glen
- unify kernel macros

Revision 1.141.2.12  2007/10/15 08:26:44  glen
- rel 55 (kernel 2.6.16.55)

Revision 1.141.2.11  2007/10/15 08:21:38  glen
- rel drbd.spec (2.6.16.55)

Revision 1.141.2.10  2007/10/01 21:25:45  glen
- rel 54

Revision 1.141.2.9  2007/09/30 22:17:50  adamg
- release 53.1 (rebuild against 2.6.16.53-2)

Revision 1.141.2.8  2007/09/05 19:30:12  glen
- rel 53 (kernel 2.6.16.53)

Revision 1.141.2.7  2007/06/04 08:09:08  glen
- rel 52 (2.6.16.52)

Revision 1.141.2.6  2007/05/11 06:38:50  glen
- rel 51 (2.6.16.51)

Revision 1.141.2.5  2007/05/08 12:10:09  glen
- rel 50 (kernel 2.6.16.50)

Revision 1.141.2.4  2007/04/25 22:11:15  glen
- rel 2 (kernel 2.6.16.49)

Revision 1.141.2.3  2007/04/20 09:37:08  matkor
- Version 8.36.5-1. Build on 2.6.20.2.

Revision 1.141.2.2  2007/03/27 22:17:52  glen
- rel 3 (kernel 2.6.16.45)

Revision 1.141.2.1  2007/03/15 23:31:49  glen
- rel 2

Revision 1.141  2007/01/01 14:34:08  matkor
- Autoupdated to 8.32.5-1. Builds on 2.6.18.1 kernel.

Revision 1.140  2006/12/08 15:26:23  hawk
- workaround for builder automation to allow building against
  kernel-grsecurity (via bcond)
- release 1

Revision 1.139  2006/11/19 02:26:11  psz
- up to 8.31.5

Revision 1.138  2006/11/15 17:06:58  sparky
- escape '\'

Revision 1.137  2006/11/15 17:00:20  sparky
- define GCC_VER_MAJ, should prevent gcc being detectted as version 64

Revision 1.136  2006/11/14 20:36:21  sparky
- BR: rpmbuild(macros) >= 1.330 -- build_kernel_modules fix for kernels 2.6.18

Revision 1.135  2006/11/13 14:51:45  sparky
- don't use %{without ...}, it may not work after inverting bcond

Revision 1.134  2006/11/13 12:41:56  sparky
- use %build_kernel_modules, %install_kernel_modules (not tested)

Revision 1.133  2006/11/02 13:46:16  matkor
- Now builds on @2.6.18.1_4

Revision 1.132  2006/11/01 14:53:14  psz
- up to 8.30.3

Revision 1.131  2006/09/25 10:08:41  shadzik
- 8.29.6
- rel 0.1, will soon be tested

Revision 1.130  2006/09/06 13:48:33  sparky
- mass atack: -j1 for make scripts

Revision 1.129  2006/08/31 18:17:34  glen
- 8.28.8 (partial merge from xorg-driver-video-fglrx.spec)

Revision 1.128  2006/08/31 17:38:36  glen
- make -j1 for scripts

Revision 1.127  2006/08/26 16:07:13  jackass
- rpmbuild(macros) >= 1.308 (required by %{_alt_kernel})

Revision 1.126  2006/08/21 14:33:04  areq
- alternative kernel support

Revision 1.125  2006/08/11 00:04:53  psz
- up to 8.27.10

Revision 1.124  2006/06/15 19:46:30  averne
- 8.25.18
- tested, works fine

Revision 1.123  2006/04/22 13:51:27  baggins
- merged changes from AC-branch

Revision 1.122  2006/04/12 11:40:46  glen
- kernel epoch, adapterized

Revision 1.121.2.3  2006/04/22 13:48:09  baggins
- release 1

Revision 1.121.2.2  2006/04/22 13:42:31  baggins
- updated to 8.24.8
- spaces -> tabs

Revision 1.121.2.1  2006/04/15 00:25:24  baggins
- release 3
- force enable support for kernel AGP drivers

Revision 1.121  2006/03/17 22:03:24  glen
- rel 2

Revision 1.120  2006/03/10 00:20:40  psz
- up to 8.23.7
- rel 1

Revision 1.119  2006/02/11 14:09:38  arekm
- rel 2

Revision 1.118  2006/02/09 22:08:00  wolf
- sources available

Revision 1.117  2006/02/08 16:29:30  wolf
- 8.22.5, binaries will be available tomorrow

Revision 1.116  2006/01/26 10:06:58  arekm
- rel 4

Revision 1.115  2006/01/12 19:06:37  arekm
- rel 3

Revision 1.114  2005/12/31 16:59:23  arekm
- fixes from Patryk Szczygłowski

Revision 1.113  2005/12/31 08:55:52  ciesiel
- upgraded to new X.org 6.9.0 (by patryk szczyglowski and some fixes)
- TODO

Revision 1.112  2005/12/29 15:39:44  charles
- pass C and CC to make

Revision 1.111  2005/12/28 00:29:34  arekm
- rel 1; proper requires

Revision 1.110  2005/12/27 21:43:29  arekm
- fix x11 requirements

Revision 1.109  2005/12/21 17:22:16  charles
- updated to 8.20.8 (by  Patryk Szczygowski patryk @ patryk one pl)
- removed obsolete -ioctl32.patch
- added missing -fglrx_pp_proto.h
- rel. 0.1 (need check x8664)

Revision 1.108  2005/11/16 12:36:01  havner
- package aticonfig binary
  (suggested by Maciej Witaszek maciek2w at gmail dot com)

Revision 1.107  2005/11/15 00:40:13  pluto
- verify_area patch merged into firegl sources.

Revision 1.106  2005/11/13 16:48:02  patrys
- up to 8.19.10
- temporarily commented out patch4 (not sure if still applicable)
- rel. 0.1

Revision 1.105  2005/11/06 07:06:04  paszczus
- fetch Source1 ; rel 1.1

Revision 1.104  2005/11/05 21:54:08  pluto
- now it builds/works fine.

Revision 1.103  2005/11/05 20:28:36  paszczus
- updated to 8.18.8
- Source{0,1} goes to DF
- removed Patch4 (amd64 builds fine)
- changes made by sebastian (at) oclab.ano.pl

Revision 1.102  2005/09/23 21:24:33  pluto
- fix x86-64 build (ioctl32 issue).

Revision 1.101  2005/09/15 18:25:04  sparky
- prepared for kernel >= 2.6.13: link Module.symvers

Revision 1.100  2005/08/17 22:40:05  wolf
- 8.16.20

Revision 1.99  2005/07/31 15:58:45  glen
- introduce some English here

Revision 1.98  2005/07/31 15:01:49  jpc
- escape %prep in comment

Revision 1.97  2005/07/27 14:44:26  adamg
- patches needed to compile firegl on 2.6.12 kernel - commented out for now
  as I suspect these break things on < 2.6.12 kernels

Revision 1.96  2005/06/10 16:36:22  wolf
- 8.14.13

Revision 1.95  2005/05/29 18:28:01  paszczus
- release 3 to rebuild with fixed viak8t patch

Revision 1.94  2005/05/11 13:22:05  qboosh
- use x8664 macro

Revision 1.93  2005/05/11 13:17:29  qboosh
- use x8664 macro

Revision 1.92  2005/05/08 15:18:19  pluto
- missed %patchX for viak8t.patch added.

Revision 1.91  2005/05/08 12:08:21  pluto
- via k8t support added (patch sent by Pawe M. Zaskrski).
- release 2.
